% LabTTR_HMM 16 maggio 2016

clear all;
close all;
clc;
addpath(genpath('./HMM/'));

%% Esercizio 1

p = [0.5 0.1 0.4];
A = [0.8 0 0.2; 0.4 0.5 0.1; 0 0.3 0.7];
B = [0.95 0.05; 0.3 0.7; 0.1 0.9];

% Due simboli: 1) Assenza di auto
%              2) Passaggio di auto

% Stato "rosso" = riga 1 di A 
% Stato "giallo" = riga 2 di A 
% Stato "verde" = riga 3 di A

%% Esercizio 1
% Generare una sequenza da 1000 elementi
% di stati e osservazioni che seguano
% il modello HMM soprascritto;

stati(1) = extract_disc_state(p);
oss(1) = extract_disc_state(B(stati(1),:));


for t = 2:1000
    
    stati(t) = extract_disc_state(A(stati(t-1),:));
    oss(t) = extract_disc_state(B(stati(t),:));
    
end

subplot(2,1,1), plot(stati(1:30))
subplot(2,1,2), plot(oss(1:30))

%% Esercizio 2
% Addestrare un HMM con la sequenza a disposizione

Q = 3; % numero di stati
O = 2; % numero di simboli

p1 = normalise(rand(Q,1));
A1 = mk_stochastic(rand(Q,Q));
B1 = mk_stochastic(rand(Q,O));

[LL, p1, A1, B1] = dhmm_em(oss, p1, A1, B1, 'max_iter', 30);

% Osservare eventuali similarit con la parametrizzazione di 
% partenza.
% Attenzione, l'ordinamento degli stati potrebbe non seguire quello
% della parametrizzazione di partenza, ovvero il primo stato ottenuto
% (di cui vedo la natura dalla prima riga di A1 e di B1)
% potrebbe essere dissimile se controllo la prima riga di A e di B


%% Esercizio 3
% Calcolare la probabilita di likelihood (con la probabilit forward)
%  della sequenza prodotta a mano rispetto ai parametri ottenuti
%  con il learning;
loglik = dhmm_logprob(oss, p1, A1, B1)

ossbad = round(unifrnd(1,2,1,1000));
loglikbad = dhmm_logprob(ossbad, p1, A1, B1)

ossbad2 = fliplr(oss);
loglikbad2 = dhmm_logprob(ossbad2, p1, A1, B1)


